package shef.dcs.cashews.commands;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;

import shef.dcs.cashews.model.Node;


public class SetConstraintCommand extends Command {

   private Node node;
   private Point newPos;
   private Point oldPos;

   public void setLocation(Point p) {
      this.newPos = p;
   }

   public void setNode(Node node) {
      this.node = node;
   }


   //------------------------------------------------------------------------
   // Overridden from Command

   public void execute() {
      oldPos = this.node.getLocation();
      this.node.setLocation(newPos);
   }

   public String getLabel() {
      return "Move Node";
   }

   public void redo() {
      this.node.setLocation(newPos);
   }

   public void undo() {
      this.node.setLocation(oldPos);
   }
}